#!/usr/bin/python

from subprocess import call, Popen, PIPE
from sys import argv
from random import shuffle
import sys, os, getopt, operator, math, datetime
import csv
from random import shuffle
from multiprocessing import Pool
import logging, ast
import getopt
import shutil
import time
import numpy as np


####################
#  post-processing #
####################
#binomial 
def binomial(n,k): 
	return math.factorial(n) / (math.factorial(k) * math.factorial(n - k))
  
#find combinations
def xuniqueCombinations(items, n):
	if n==0: yield []
	else:
		for i in xrange(len(items)):
			for cc in xuniqueCombinations(items[i+1:],n-1):
				yield [items[i]]+cc


# run of argenet 
def postpro((folder, s, c, tp, times)):

	path= os.path.dirname(os.path.abspath(__file__))
	path = path + "/"


	numEmpty=0
	pass_threshold_set_file = folder + "over_threshold_set"
	pass_threshold_num_file = folder + "over_threshold_num"
	similarity_file = folder + "average_similarity.txt"
	allSimilarity_file = folder + "allSimilarityJaccardSimple.txt"
	numEmpty_file = folder + "numEmpty.txt"
	avglen_file = folder + "avgLen.txt"
	stdlen_file = folder + "stdLen.txt"
	min_file = folder + "min.txt"

	sim1=0.0
	sim2=0.0
	sim3=0.0
	sim4=0.0
	sim5=0.0
	sim6=0.0

	l = []
	allSim_type1 = []
	n_times = {}
	inter = {}
	result={}
	avg_len = 0.0
	std_dev = 0.0
	len_list = []
	min_len= 100000000

	#check the type, 1 for non disjoint run, 2 for disjoint
	if(tp == 1):
		for i in range(times):
			l.append(folder + str(i) +"/" + "Ncol" + "-Ssize" + str(s) + "Corr" + str(c) + "-Perm" + str(i)+ ".txt")

		arc_map = {}
		for f1 in l:
			if(os.stat(f1)[6]!=0):
				with open(f1) as f:
					for row in f.readlines():
						gene_from, gene_to, weight  = row.split('\t')
						arc_map[str(gene_from) + "\t" + str(gene_to)]=float(weight)


			keys = set(arc_map.keys())

			len_list.append(len(arc_map))

			if(len(arc_map) < min_len):
				min_len= len(arc_map)
				
			for k in keys:
				try:
					result[k] = result[k] + arc_map[k]
					n_times[k] = n_times[k] + 1
				except:
					result[k] = arc_map[k]
					n_times[k] = 1

			arc_map={}

		#make arcs that pass the threshold in different senses as double directed edges
		number = 0
		for k in result.keys():
			a,b = k.split("\t")
			try:
				if(n_times[k] < 7):
					# if they pass the threshold summing their frequences
					if(n_times[b+"\t"+a] +  n_times[k] >= 7):
						number += 1
			except:
				pass

		with open(folder + "number_arcs_reversedGretaer7.txt", 'w') as out_file:
			out_file.write(str(number))
		time.sleep(1)


		# plt.hist(n_times.values(), bins=[0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10,11])
		# plt.savefig(folder + "frequency_common_edges.png")
		# plt.clf()

		#save only the edges with frequency > 50%
		threshold= int(0.5 * times)
		edges_over_threshold = {}
		for val in result.keys():
			if(n_times[val] >= threshold):
				edges_over_threshold[val] = result[val] / n_times[val]

		with open(pass_threshold_num_file + str(threshold) + ".txt", 'w') as out_file:
			out_file.write(str(len(edges_over_threshold.items())))

		time.sleep(1)

		list_pass_threshold=""
		for p in edges_over_threshold.items():
			list_pass_threshold += ("%s\t%s\n" % p)

		if(len(edges_over_threshold.items()) > 0):
			with open(pass_threshold_set_file + str(threshold) + ".txt", 'w') as out_file:
				out_file.write(list_pass_threshold)
		else:
			open(pass_threshold_set_file+ str(threshold) + ".txt", 'w').close()

		time.sleep(1)

		#save only the edges with frequency > 60%
		threshold= int(0.6 * times)
		edges_over_threshold = {}
		for val in result.keys():
			if(n_times[val] >= threshold):
				edges_over_threshold[val] = result[val] / n_times[val]

		with open(pass_threshold_num_file + str(threshold) + ".txt", 'w') as out_file:
			out_file.write(str(len(edges_over_threshold.items())))

		time.sleep(1)

		list_pass_threshold=""
		for p in edges_over_threshold.items():
			list_pass_threshold += ("%s\t%s\n" % p)

		if(len(edges_over_threshold.items()) > 0):
			with open(pass_threshold_set_file + str(threshold) + ".txt", 'w') as out_file:
				out_file.write(list_pass_threshold)
		else:
			open(pass_threshold_set_file+ str(threshold) + ".txt", 'w').close()

		time.sleep(1)

		#save only the edges with frequency > 70%
		threshold = int(0.7 * times)
		edges_over_threshold = {}
		for val in result.keys():
			if(n_times[val] >= threshold):
				edges_over_threshold[val] = result[val] / n_times[val]

		with open(pass_threshold_num_file + str(threshold) + ".txt", 'w') as out_file:
			out_file.write(str(len(edges_over_threshold.items())))

		time.sleep(1)

		list_pass_threshold=""
		for p in edges_over_threshold.items():
			list_pass_threshold += ("%s\t%s\n" % p)

		if(len(edges_over_threshold.items()) > 0):
			with open(pass_threshold_set_file + str(threshold) + ".txt", 'w') as out_file:
				out_file.write(list_pass_threshold)
		else:
			open(pass_threshold_set_file + str(threshold) + ".txt", 'w').close()

		time.sleep(1)

		#save only the edges with frequency > 80%
		threshold = int(0.8 * times)
		edges_over_threshold = {}
		for val in result.keys():
			if(n_times[val] >= threshold):
				edges_over_threshold[val] = result[val] / n_times[val]

		with open(pass_threshold_num_file + str(threshold) + ".txt", 'w') as out_file:
			out_file.write(str(len(edges_over_threshold.items())))

		time.sleep(1)

		list_pass_threshold=""
		for p in edges_over_threshold.items():
			list_pass_threshold += ("%s\t%s\n" % p)

		if(len(edges_over_threshold.items()) > 0):
			with open(pass_threshold_set_file + str(threshold) + ".txt", 'w') as out_file:
				out_file.write(list_pass_threshold)
		else:
			open(pass_threshold_set_file+ str(threshold) + ".txt", 'w').close()

		time.sleep(1)

		#save only the edges with frequency > 90%
		threshold= int(0.9 * times)
		edges_over_threshold = {}
		for val in result.keys():
			if(n_times[val] >= threshold):
				edges_over_threshold[val] = result[val] / n_times[val]

		with open(pass_threshold_num_file + str(threshold) + ".txt", 'w') as out_file:
			out_file.write(str(len(edges_over_threshold.items())))

		time.sleep(1)

		list_pass_threshold=""
		for p in edges_over_threshold.items():
			list_pass_threshold += ("%s\t%s\n" % p)

		if(len(edges_over_threshold.items()) > 0):
			with open(pass_threshold_set_file + str(threshold) + ".txt", 'w') as out_file:
				out_file.write(list_pass_threshold)
		else:
			open(pass_threshold_set_file + str(threshold) + ".txt", 'w').close()

		time.sleep(1)

		#save only the edges with frequency = 100%
		threshold= times
		edges_over_threshold = {}
		for val in result.keys():
			if(n_times[val] >= threshold):
				edges_over_threshold[val] = result[val] / n_times[val]

		with open(pass_threshold_num_file + str(threshold) + ".txt", 'w') as out_file:
			out_file.write(str(len(edges_over_threshold.items())))


		# with open(inters_file, 'w') as out_file:
		# 	out_file.write(str(len(edges_over_threshold.items())))

		time.sleep(1)

		list_pass_threshold=""
		for p in edges_over_threshold.items():
			list_pass_threshold += ("%s\t%s\n" % p)

		if(len(edges_over_threshold.items()) > 0):
			with open(pass_threshold_set_file + str(threshold) + ".txt", 'w') as out_file:
				out_file.write(list_pass_threshold)
		else:
			open(pass_threshold_set_file + str(threshold) + ".txt", 'w').close()

		time.sleep(1)

		# if(len(edges_over_threshold.items()) > 0):
		# 	with open(inters_set_file, 'w') as out_file:
		# 		out_file.write(list_pass_threshold)
		# else:
		# 	open(inters_set_file, 'w').close()


		time.sleep(1)

		#get the combinations
		comb = xuniqueCombinations(l, 2)
		for f1,f2 in comb:
			arc_A_map = {}
			arc_B_map = {}

			#open 1 file
			if(os.stat(f1)[6]!=0):
				with open(f1) as f:
					for row in f.readlines():
						gene_from, gene_to, weight  = row.split('\t')
						arc_A_map[str(gene_from) + "\t" + str(gene_to)]=float(weight)

			#open the other file
			if(os.stat(f2)[6]!=0):				
				with open(f2) as f:
					for row in f.readlines():
						gene_from, gene_to, weight  = row.split('\t')
						arc_B_map[str(gene_from) + "\t" + str(gene_to)]=float(weight)
	

			#inters = set(inters.intersection(set(arc_A_map).intersection(set(arc_B_map))))


			if(os.stat(f1)[6]==0 or os.stat(f2)[6]==0):
				numEmpty+=1

			logging.info("working on -Ssize" + str(s) + "-cor" + str(c))
			try:
				p = Popen(["python", path + "jaccard.py", str(f1), str(f2)], stdout=PIPE)
				p.wait()
				f = float(p.stdout.readline())
				allSim_type1.append(f)
				sim1 += f
				sim2 += float(p.stdout.readline())
				sim3 += float(p.stdout.readline())
				sim4 += float(p.stdout.readline())
				sim5 += float(p.stdout.readline())
				sim6 += float(p.stdout.readline())
			except:
				print("error")
			 	p.kill()
		 		return 1
		binom = binomial(times,2)

		with open(similarity_file, 'w') as out_file:
			s = "Jaccard_simple\tJaccard_subset\tRefined_simple\tRefined_subset\tWeighted_simple\tWeighted_subset\n"
			s += str(sim1/binom) + "\t" + str(sim2/binom) + "\t" +  str(sim3/binom) + "\t" + str(sim4/binom) + "\t" + str(sim5/binom) + "\t" + str(sim6/binom)
			out_file.write(s)

		time.sleep(1)

		s=""
		for val in allSim_type1[:-1]:
			s += str(val) + "\t"
		s+=str(allSim_type1[-1])

		time.sleep(1)

		with open(allSimilarity_file, 'w') as out_file:
			out_file.write(s)

		time.sleep(1)

		with open(numEmpty_file, 'w') as out_file:
			out_file.write(str(numEmpty))

		time.sleep(1)


		with open(avglen_file, 'w') as out_file:
			out_file.write(str(np.mean(len_list)))

		time.sleep(1)

		with open(stdlen_file, 'w') as out_file:
			out_file.write(str(np.std(len_list)))

		time.sleep(1)

		with open(min_file, 'w') as out_file:
			out_file.write(str(min_len))

	#type 2, disjoint input of ARGENET
	elif(tp == 2):

		f1 = folder +"1/1/" + "Ncol" + "-Ssize" + str(s) + "-Corr" + str(c) + "-Perm1.txt"

		if(os.stat(f1)[6]!=0):
			with open(f1) as f:
				for row in f.readlines():
					gene_from, gene_to, weight, errormin, errormax  = row.split('\t')
					inter[str(gene_from) + ">" + str(gene_to)]=(float(weight), float(errormin), float(errormax))

		inters = set(inter)


		for i in range(times):
			arc_A_map = {}
			arc_B_map = {}
			f1 = folder  + str(i) +"/1/" + "Ncol" + "-Ssize" + str(s) + "Corr" + str(c) + "-Perm" + str(i)+ ".txt"
			f2 = folder  + str(i) +"/2/" + "Ncol" + "-Ssize" + str(s) + "Corr" + str(c) + "-Perm" + str(i)+ ".txt"

			if(os.stat(f1)[6]!=0):
				with open(f1) as f:
					for row in f.readlines():
						gene_from, gene_to, weight, errormin, errormax  = row.split('\t')
						arc_A_map[str(gene_from) + ">" + str(gene_to)]=(float(weight), float(errormin), float(errormax))

			if(os.stat(f2)[6]!=0):				
				with open(f2) as f:
					for row in f.readlines():
						gene_from, gene_to, weight, errormin, errormax  = row.split('\t')
						arc_B_map[str(gene_from) + ">" + str(gene_to)]=(float(weight), float(errormin), float(errormax))

			avg_len+= len(arc_A_map)
			avg_len += len(arc_B_map)

			if(len(arc_A_map) < min_len):
				min_len= len(arc_A_map)

			if(len(arc_B_map) < min_len):
				min_len= len(arc_B_map)

			inters = set(inters.intersection(set(arc_A_map).intersection(set(arc_B_map))))

			if(os.stat(f1)[6]==0 or os.stat(f2)[6]==0):
				numEmpty+=1

			logging.info("working on -Ssize" + str(s) + "-cor" + str(c))
			try:
				p = Popen(["python", path + "jaccard.py", str(f1), str(f2)], stdout=PIPE)
				p.wait()
				f = float(p.stdout.readline())
				allSim_type1.append(f)
				sim1 += f
				sim2 += float(p.stdout.readline())
				sim3 += float(p.stdout.readline())
				sim4 += float(p.stdout.readline())
				sim5 += float(p.stdout.readline())
				sim6 += float(p.stdout.readline())
			except:
				print("error")
			 	p.kill()
		 		return 1

		binom = 10
		avg_len /=  20


		with open(similarity_file, 'w') as out_file:
			s = str(sim1/binom) + "\t" + str(sim2/binom) + "\t" +  str(sim3/binom) + "\t" + str(sim4/binom) + "\t" + str(sim5/binom) + "\t" + str(sim6/binom)
			out_file.write(s)

		s=""
		for val in allSim_type1[:-1]:
			s += str(val) + "\t"
		s+=str(allSim_type1[-1])


		with open(allSimilarity_file, 'w') as out_file:
			out_file.write(s)

		with open(numEmpty_file, 'w') as out_file:
			out_file.write(str(numEmpty))


		with open(inters_file, 'w') as out_file:
			out_file.write(str(len(inters)))

		inters= list(inters)
		if(len(inters) > 0):
			s=""
			for val in inters[:-1]:
				s += str(val) + "\n"
			s+=str(inters[-1])

		if(len(inters) > 0):
			with open(inters_set_file, 'w') as out_file:
				out_file.write(s)
		else:
			open(inters_set_file, 'w').close()


		with open(avglen_file, 'w') as out_file:
			out_file.write(str(avg_len))

		with open(min_file, 'w') as out_file:
			out_file.write(str(min_len))

	return 0


# multi run of argenet
def iteration_argenet((experiment, sample_size,permutation, obs_file, f, correlations, alpha)):

	if os.name == 'nt':
		slash = "\\"
	else:
		slash = "/"

	path= os.path.dirname(os.path.abspath(__file__))
	path = path + slash


	# correlation thresholds to use, only the first will launch ARGENET

	for corr in correlations:
		folder = experiment + slash + "Sample-size" + str(sample_size) + slash + "Corr-" + str(corr) + slash + str(permutation) + slash
		if not os.path.exists(folder): 
			os.makedirs(folder)

		if(corr == correlations[0]):				
			# log start
			logging.info("Correlation: " + str(corr) + " - Sample size: " + str(sample_size) + " - Permunation # " + str(permutation))
			
			# execute ARGENET	
			param_to_execute = ["Rscript", path + "ARGENET.r", str(obs_file), str(f), folder + "complete.txt", folder + "final.txt", str(corr) , str(alpha), folder + "min.txt", folder + "time.txt"]
			try:
			 	p = Popen(param_to_execute, stdout=PIPE, stderr=PIPE)
				stdout, stderr = p.communicate()

			except Exception as e:
				logging.info("ERROR!!! -> Correlation: " + str(corr) + " - Sample size: " + str(sample_size) + " - Permunation # " + str(permutation) + "  -- " + str(e))
			 	print("ERROR ARGENET: " + str(e))

			
			param_to_execute = ["Rscript", path + "parserRPKM_simple.r", folder + "final.txt", folder + "Ncol" + "-Ssize" + str(sample_size) + "Corr" + str(corr) + "-Perm" + str(permutation)+ ".txt"]
			try:
				call(param_to_execute)
			except Exception as e:
				logging.info("ERROR!!! -> Correlation: " + str(corr) + " - Sample size: " + str(sample_size) + " - Permunation # " + str(permutation) + "  -- " + str(e))
			 	print("ERROR parser: " + str(e))
		else:
			logging.info("Correlation: " + str(corr) + " - Sample size: " + str(sample_size) + " - Permunation # " + str(permutation))
			# filter ARGENET output with the give correlation
			param_to_execute = ["Rscript", path + "filterFinal.r", experiment + slash + "Sample-size" + str(sample_size) + slash + "Corr-" + str(correlations[0]) + slash + str(permutation) + slash + "final.txt", str(corr), str(alpha), folder + "final.txt"]
			try:
			 	call(param_to_execute)
			except:
				print "ERROR in filtering phase"
				logging.info("ERROR!!! -> Correlation: " + str(corr) + " - Sample size: " + str(sample_size) + " - Permunation # " + str(permutation))
			 	return 1

			try:
			 	# parser ARGENET output to ncol file
				param_to_execute = ["Rscript", path + "parserRPKM_simple.r", folder + "final.txt", folder + "Ncol" + "-Ssize" + str(sample_size) + "Corr" + str(corr) + "-Perm" + str(permutation)+ ".txt"]
				call(param_to_execute)
			except:
				print "ERROR in creating ncol file with correlation " + str(corr)
				logging.info("ERROR!!! -> Correlation: " + str(corr) + " - Sample size: " + str(sample_size) + " - Permunation # " + str(permutation))
			 	return 1
	return 0


def usage():
    print "SYNOPSIS:"
    print "\command-line.py -o observation_file -f output_folder -s sample_sizes -c correlations -i iterations_number -a alpha -t threads_number -h help\n"
    print "PARAMS:"
    print "\t-o\tThe path of the observation file \n"
    print "\t-f\tThe path of the folder where to save the computations \n"
    print "\t-s\tSample sizes to use, given as list: e.g.[50,100,..]\n"
    print "\t-c\tThe correlations to use, given as list: e.g. [0.5,0.6,...]\n"
    print "\t-i\tThe number of iterations\n"
    print "\t-a\tThe alpha value to use for the statistical test\n"
    print "\t-t\tThe number of threads to use\n"
    print "\t-h\tThis tutorial\n"


if __name__ == '__main__':

	if os.name == 'nt':
		slash = "\\"
	else:
		slash = "/"

	obs_file=""
	experiment=""
	sample_size=[]
	correlations=[]
	iterations=0
	alpha=0
	threadNumber=0

	try:
		opts, args = getopt.getopt(argv[1:], "o:f:s:c:i:a:t:hsp")
	except getopt.GetoptError as err:
		# print help information and exit:
		print str(err) # will print something like "option -a not recognized"
		usage()
		sys.exit(2)

 	for o, v in opts:
		if o == "-o":
			obs_file = v
		elif o == "-f":
			experiment = v
		elif o == "-s":
			sample_size = ast.literal_eval(v)
		elif o == "-c":
			correlations = ast.literal_eval(v)
		elif o == "-i":
			iterations = int(v)
		elif o == "-a":
			alpha = float(v)
		elif o == "-t":
			threadNumber = int(v)
		elif o == "-h":
			usage()
			sys.exit(2)

	if(obs_file==""):
		print "[ERR] The options -o must be specified\n"
		usage()
		sys.exit(2)

	if(experiment==""):
		print "[ERR] The options -f must be specified\n"
		usage()
		sys.exit(2)

	if(not sample_size):
		print "[ERR] The options -s must be specified\n"
		usage()
		sys.exit(2)

	if(not correlations):
		print "[ERR] The options -c must be specified\n"
		usage()
		sys.exit(2)

	if(iterations == 0):
		print "[ERR] The options -i must be specified and not qual to 0\n"
		usage()
		sys.exit(2)

	if(alpha == 0):
		print "[ERR] The options -a must be specified and not qual to 0\n"
		usage()
		sys.exit(2)

	if(threadNumber == 0):
		print "[ERR] The options -t must be specified and not qual to 0\n"
		usage()
		sys.exit(2)

	experiment = experiment + "_" + datetime.datetime.now().strftime('%Y-%m-%d_%H-%M-%S')
	os.makedirs(experiment)
	
	# parameters used to call threads
	params_list = []

	logging.getLogger().setLevel(logging.WARNING)
	logger = logging.getLogger()
	logger.setLevel(logging.DEBUG)
	#log to file
	handler = logging.FileHandler(os.path.join( experiment + "log.txt"),"w", encoding=None, delay="true")
	formatter = logging.Formatter("%(asctime)s %(levelname)s - %(message)s")
	handler.setFormatter(formatter)
	logger.addHandler(handler)


	# read input file
	with open(obs_file) as input:
		input_file = zip(*(line.strip().split('\t') for line in input))

	# index of samples
	samples = [i+1 for i in range(len(input_file) - 1)]

	logging.info("Start loop\n")
	for s in sample_size:
		for permutation in range(iterations):
			#create output folder
			folder = experiment + slash +"Sample-size" + str(s) + slash
			if not os.path.exists(folder): 
				os.makedirs(folder)

			# shuffle samples and take the needed subset
			shuffle(samples)
			subset=[0]+samples[:s]

			# select samples 
			subset_permutation = []
			for j in subset:
				subset_permutation.append(input_file[j])

			subset_permutation1=map(list, zip(*subset_permutation))

			f = folder+'perm-'+ str(permutation) + "-input.txt"

			# write output file 
			with open(f, 'w') as file:
				file.write("\t".join(subset_permutation1[0]))

			params_list.append((experiment, s, permutation, obs_file, f, correlations, alpha))

	sys.stdout.write('\nStarting argenet execution on ' + str(threadNumber) + ' threads\n\n')

	pool = Pool(threadNumber)
	pool.map(iteration_argenet, params_list)
	pool.close()
	pool.join()

	# argenet with non disjoint input
	tp = 1
	params_list=[]

	# start postprocessing
	logging.info("Start loop\n")
	for s in sample_size:
		for c in correlations:
			#create output folder

			folder = experiment + slash + "Sample-size" + str(s) + slash + "Corr-" + str(c) + slash
			params_list.append((folder,s,c,tp,iterations))


	sys.stdout.write('\nStarting post-processing on ' + str(threadNumber) + ' threads\n\n')
	pool = Pool(threadNumber)
	pool.map(postpro, params_list)
	pool.close()
	pool.join()
